// This may look like C code, but it is really -*- C++ -*-
/****************************************************************************
** $Id: fancyint.h 422 2009-08-15 19:25:40Z wglas $
**
** Copyright (C) 2003 EV-i Informationstechnologie GmbH
**
** Author: Wolfgang Glas / EV-i
**
** A frontend header for encapsulating fixed-size integral types.
**
*****************************************************************************/

#ifndef FANCYBASE_INT_H
#define FANCYBASE_INT_H

#ifndef __STDC_CONSTANT_MACROS
#define __STDC_CONSTANT_MACROS
#endif
#ifndef __STDC_LIMIT_MACROS
#define __STDC_LIMIT_MACROS
#endif
#include <stdint.h>

// FANCY_INT64_T_FMT is the format specifier for printf et al. for int64_t
// FANCY_UINT64_T_FMT is the format specifier for printf et al. for uint64_t
#ifdef WIN32
#define FANCY_INT64_T_FMT_LENGTH "I64"
#define FANCY_INT64_T_FMT  "%I64d"
#define FANCY_UINT64_T_FMT "%I64u"
#elif __WORDSIZE == 64
#define FANCY_INT64_T_FMT_LENGTH "l"
#define FANCY_INT64_T_FMT  "%ld"
#define FANCY_UINT64_T_FMT "%lu"
#else
#define FANCY_INT64_T_FMT_LENGTH "ll"
#define FANCY_INT64_T_FMT  "%lld"
#define FANCY_UINT64_T_FMT "%llu"
#endif

// FANCY_SIZE_T_FMT is the format specifier for printf et al. for size_t
// FANCY_SIZE_T_FMT_ARG casts size_t args for printf et al. in order to avoid gcc warnings.
#ifdef WIN64
#define FANCY_SIZE_T_FMT  "%I64u"
#define FANCY_SIZE_T_FMT_ARG(a) ((uint64_t)(a))
#define FANCY_SSIZE_T_FMT  "%I64d"
#define FANCY_SSIZE_T_FMT_ARG(a) ((int64_t)(a))
#elif defined ( WIN32 )
#define FANCY_SIZE_T_FMT "%lu"
#define FANCY_SIZE_T_FMT_ARG(a) ((unsigned long)(a))
#define FANCY_SSIZE_T_FMT "%ld"
#define FANCY_SSIZE_T_FMT_ARG(a) ((long)(a))
#else
#define FANCY_SIZE_T_FMT "%zu"
#define FANCY_SIZE_T_FMT_ARG(a) (a)
#define FANCY_SSIZE_T_FMT "%zd"
#define FANCY_SSIZE_T_FMT_ARG(a) (a)
#endif

#endif
