/*
 * fancylist.h
 *
 *  Created on: 13.05.2009
 *      Author: wglas
 */

#ifndef FANCYQUEUE_H_
#define FANCYQUEUE_H_

#include <fancylist.h>

namespace Fancy {

class Iterator;

/*!
 * An interface for an untyped queue of objects.
 * This is pretty much like \c java.util.Queue and is used in favor
 * to a template in order to avoid code-bloat and to allow a generic
 * deserializer to be implemented.
 */
class FANCYBASE_API Queue: public virtual List {
public:
    typedef ObjPtr<Queue> ptr_t;

    virtual void addFront(const ObjPtr<Object> &o) = 0;
    virtual ObjPtr<Object> popFront() = 0;

    static ObjPtr<Queue> newInstance();
    static ObjPtr<Queue> newInstance(getSerialID_s_t getSerialID_s, getSerialVersionUID_s_t getSerialVersionUID_s);

    template <class T> static ObjPtr<Queue> newTypedInstance() {
        return Queue::newInstance(T::getSerialID_s,T::getSerialVersionUID_s);
    }

protected:
    Queue() {}
    virtual ~Queue();
};

}

#endif /* FANCYQUEUE_H_ */
