/*
 * fancyrandom.h
 *
 *  Created on: 29.05.2009
 *      Author: wglas
 */

#ifndef FANCYRANDOM_H_
#define FANCYRANDOM_H_

#include <fancyobject.h>

namespace Fancy {

/**
 * This class
 */
class FANCYBASE_API Random: public Fancy::Object {

public:
    typedef ObjPtr<Random>  ptr_t;

    /**
     * Return a new instance of random. The returned instance is a suitable
     * implementation for you current operating system.
     */
    static ptr_t newInstance();

    /**
     * Generate a sequence of random bytes.
     */
    virtual void generateBytes(uint8_t *buf, int n) = 0;

    /**
     * Generate a 32 bit random number.
     */
    virtual uint32_t generateInt() = 0;

    /**
     * Generate a 64b bit random number.
     */
    virtual uint64_t generateLong() = 0;

protected:
    Random() {}
    virtual ~Random();
};

}

#endif /* FANCYRANDOM_H_ */
