/*
 * fancyserializer.h
 *
 *  Created on: 11.05.2009
 *      Author: wglas
 */

#ifndef FANCYSERIALIZER_H_
#define FANCYSERIALIZER_H_

#include <fancydatastream.h>

namespace Fancy {

class List;
class Set;
class Map;
class SerializableFactory;
class EnumInfo;

class FANCYBASE_API Serializer: public virtual Fancy::DataStream {
public:
    typedef ObjPtr<Serializer> ptr_t;

    /**
     * Return a new default implementation instance, which writes to
     * the given stream.
     */
    static ptr_t newInstance(const DataStream::ptr_t& stream, const ObjPtr<SerializableFactory> &sf);

    Serializer() { }

    virtual ObjPtr<Object> readObject() = 0;
    virtual void writeObject (const ObjPtr<Object> &obj) = 0;

    virtual DataStream::ptr_t getStream() const = 0;
    virtual ObjPtr<SerializableFactory> getSerializableFactory() const = 0;

protected:
    virtual ~Serializer();
};

}

#endif /* FANCYSERIALIZER_H_ */
