// This may look like C code, but it is really -*- C++ -*-
/****************************************************************************
** $Id: fancysignal.h 510 2009-11-30 14:27:52Z wglas $
**
** Copyright (C) 2003 EV-i Informationstechnologie GmbH
**
** Author: Wolfgang Glas / EV-i
**
** Global signal handling stuff.
** 
*****************************************************************************/

#ifndef FANCYBASE_SIGNAL_H
#define FANCYBASE_SIGNAL_H

#include <sys/types.h>
#include <fancybase.h>

#define FANCY_SIGNAL_HUP   1
#define FANCY_SIGNAL_INT   2
#define FANCY_SIGNAL_QUIT  3
#define FANCY_SIGNAL_ILL   4
#define FANCY_SIGNAL_TRAP  5
#define FANCY_SIGNAL_ABRT  6
#define FANCY_SIGNAL_FPT   8
#define FANCY_SIGNAL_KILL  9
#define FANCY_SIGNAL_SEGV 11
#define FANCY_SIGNAL_PIPE 13
#define FANCY_SIGNAL_ALRM 14
#define FANCY_SIGNAL_TERM 15

namespace Fancy {

  FANCYBASE_API void installSignalHandlers();
  FANCYBASE_API void installNewHandler(size_t reserve);

  FANCYBASE_API void mallocFailHandler();

  FANCYBASE_API void sendSignal(int sig);

#ifdef WIN32
  FANCYBASE_API void *getSignalWinEventHandle();
#endif

  FANCYBASE_API void resetHupSignalCatched();
  FANCYBASE_API int getHupSignalCatched();

  FANCYBASE_API void resetStopSignalCatched();
  FANCYBASE_API int getStopSignalCatched();

  FANCYBASE_API void resetUsrSignalCatched();
  FANCYBASE_API int getUsrSignalCatched();

}

#endif // ! FANCYBASE_SIGNAL_H
